#include "xparameters.h"
#include "xil_io.h"
#include "xil_printf.h"
#include "xil_types.h"

// Xilinx self generated driver
#include "myAXIpwm.h"

// Get device IDs from xparameters.h
#define PWM_ID 			XPAR_MYAXIPWM_0_DEVICE_ID
#define PWM_BASE_ADR	XPAR_MYAXIPWM_0_S00_AXI_BASEADDR

// PWM registers
#define PWM_CTRL_REG		MYAXIPWM_S00_AXI_SLV_REG0_OFFSET
#define PWM_COUNT_REG		MYAXIPWM_S00_AXI_SLV_REG1_OFFSET

// Control register masks
#define ENABLE_MASK			(1<<31)
#define PULSE_WIDTH_MASK	0x7			// TODO: grab generic parameter value ?

int main() {

	xil_printf("\n### AXI PWM IP app.\n\tEntered function main\r\n");

	// enable PWM
	unsigned int CR;
	CR = MYAXIPWM_mReadReg(PWM_CTRL_REG, PWM_BASE_ADR);
	CR = CR & not(ENABLE_MASK);

	xil_printf("\tPWM IP enabled ...");

	// set pulse width value
	CR = MYAXIPWM_mReadReg(PWM_CTRL_REG, PWM_BASE_ADR);
	// set PULSE_WIDTH value to MID

	while (1) {

		// sleep(1);
		// TODO: fade-in / fade-out
	}
}
